> ## Documentation Index
> Fetch the complete documentation index at: https://cobo-docs-feature-cobo-cli.mintlify.site/llms.txt
> Use this file to discover all available pages before exploring further.

# Changelog

This changelog details all additions and changes to the WaaS 2.0 API. You can download the WaaS 2.0 API specification from [GitHub](https://github.com/CoboGlobal/developer-site/blob/master/v2/cobo_waas2_openapi_spec/dev_openapi.yaml).

## v1.4.0

This version was released on September 25, 2024.

### Improvements

* Improved the tracking of transactions by adding and removing certain statuses and sub-statuses in the `TransactionStatus` and `TransactionSubStatus` schemas.
* Added the `MPCProcessing` status in the `TSSRequestStatus` schema to indicate that the TSS request approval is waiting to be started.
* Removed the `nonce` property in the `MpcContractCallSource` schema.

## v1.3.0

This version was released on September 12, 2024.

### New features

* You can now stake your tokens with the WaaS 2.0 API. Staking operations include:
  * [List staking positions](/v2/api-references/stakings/list-staking-positions)
  * [Get staking position details](/v2/api-references/stakings/get-staking-position-details)
  * [List staking activities](/v2/api-references/stakings/list-staking-activities)
  * [Estimate staking fees](/v2/api-references/stakings/estimate-staking-fees)
  * [Create stake activity](/v2/api-references/stakings/create-stake-activity)
  * [Create unstake activity](/v2/api-references/stakings/create-unstake-activity)
  * [Create withdraw activity](/v2/api-references/stakings/create-withdraw-activity)
  * [Get staking activity details](/v2/api-references/stakings/get-staking-activity-details)
  * [List staking pools](/v2/api-references/stakings/list-staking-pools)
  * [Get staking pool details](/v2/api-references/stakings/get-staking-pool-details)
* Added the [Broadcast signed transactions](/v2/api-references/transactions/broadcast-signed-transactions) operation to broadcast signed transactions.

### Improvements

* Changed the path of the [Check Cobo Loop transfers](/v2/api-references/transactions/check-cobo-loop-transfers) operation from `/wallets/check_loop_transfers` to `/transactions/check_loop_transfers`.
* Added the `dust_threshold` and `custodial_minimum_deposit_threshold` properties in the `TokenInfo` schema to indicate the minimum withdrawal and deposit amounts for Custodial Wallets.
* Added the `confirming_threshold` property in the `ChainInfo` schema to indicate the number of confirmations required for a transaction on each chain.

### Bug fixes

* Fixed an issue with using WaaS SDKs to perform operations relating to contract call or message signing.

## v1.2.0

This version was released on August 21, 2024.

### New features

* Added support for [Exchange Wallets](https://manuals.cobo.com/en/portal/exchange-wallets/introduction) and [Smart Contract Wallets](https://manuals.cobo.com/en/portal/smart-contract-wallets/introduction). Added the following operations for Exchange Wallets:
  * [List supported exchanges](/v2/api-references/wallets--exchange-wallet/list-supported-exchanges)
  * [List supported assets](/v2/api-references/wallets--exchange-wallet/list-supported-assets)
  * [List supported chains](/v2/api-references/wallets--exchange-wallet/list-supported-chains)
  * [List asset balances](/v2/api-references/wallets--exchange-wallet/list-asset-balances)
* Added the following operations for batch payment:
  * [Check addresses validity](/v2/api-references/wallets/check-addresses-validity)
  * [Check Cobo Loop transfers](/v2/api-references/transactions/check-cobo-loop-transfers)
* You can now subscribe to TSS request-related event types for your webhook endpoints. For more information about TSS request-related event types, refer to [Webhook event types and data types](/v2/guides/webhooks-callbacks/webhook-event-type).

### Improvements

* The `sub_wallet_id` property was renamed as `trading_account_type`. Affected schemas include:
  * `ExchangeTransferSource`
  * `ExchangeTransferDestination`
  * `TransactionTransferToWalletDestination`
  * `TransactionExchangeWalletSource`
  * `TransactionDepositFromWalletSource`
  * `TransactionDepositToWalletDestination`
* Added the `PendingApprovalStart` enum value in the `TransactionSubStatus` enum to indicate a status that requires specific action from users for proceeding with the transaction.
* Added the `project_name` and `vault_name` properties in the `MPCWalletInfo` schema to indicate the project name and vault name.
* Added the `description` and `created_timestamp` properties in the `TSSRequest` schema to indicate the description and creation time of the TSS request.
* Added the `account_id` property in the `KeyShareHolder` schema to indicate the key share holder’s account ID on Cobo Portal.
* Added the `signer_key_share_holder_group_id` property in the `TransactionMPCWalletSource` schema to indicate the ID of the key share holder group as the transaction signer.
* Added the `description` property in the request body of [Create TSS request](/v2/api-references/wallets--mpc-wallets/create-tss-request) to indicate the description of the TSS request.

## v1.1.0

This version was released on August 7, 2024.

### New features

Added OAuth operations for Cobo Portal App developers:

* [Get access token](/v2/api-references/oauth/get-org-access-token)
* [Refresh access token](/v2/api-references/oauth/refresh-org-access-token)

### Improvements

* The data type of `data.response_body` was updated from object to string in the response of [List webhook event logs](/v2/api-references/developers--webhooks/list-webhook-event-logs).
* Added the `signer` property to indicate whether the key share holder's TSS Node is a designated transaction signer. Affected schemas include:
  * `CreateKeyShareHolder`
  * `KeyShareHolder`
* The `node_count` property was renamed as `participants` in:
  * The request body of [Create project](/v2/api-references/wallets--mpc-wallets/create-project)
  * The request body of [Create key share holder group](/v2/api-references/wallets--mpc-wallets/create-key-share-holder-group)
  * The `KeyShareHolderGroup` schema
  * The `MPCProject` schema
* The `pubkey` property was renamed as `root_pubkey` in the `RootPubkey` schema.
* Added the `root_pubkey` property to indicate the vault's root extended public key in the `TSSGroups` schema.
* Several timestamp-related properties were renamed using the “\_timestamp” suffix. Affected schemas include:
  * `Transaction`
  * `TransactionBlockInfo`
  * `TransactionTimeline`
  * `KeyShareHolderGroup`
  * `MPCVault`

## v1.0.0

This is the first release of the Cobo WaaS 2.0 API.

This release includes support for [Custodial Wallets](https://manuals.cobo.com/en/portal/custodial-wallets/introduction) and [MPC Wallets](https://manuals.cobo.com/en/portal/mpc-wallets/introduction), with the following categories of operations:

* [General wallet operations](/v2/api-references/wallets/list-supported-chains)
* [MPC Wallets-specific operations](/v2/api-references/wallets--mpc-wallets/list-all-cobo-key-share-holders)
* [Transactions operations](/v2/api-references/transactions/estimate-transaction-fee)
* [Webhook operations](/v2/api-references/developers--webhooks/list-webhook-endpoints)
